## dynmhs 0.2.4

=== debian/changelog ===
dynmhs (0.2.4-1) unstable; urgency=low

  * Closes: #1099114 (ITP).

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 24 Oct 2025 13:29:41 +0200
