=== debian/changelog ===
dynmhs (0.3.0-1) unstable; urgency=low

  * Closes: #1099114 (ITP).

 -- Thomas Dreibholz <dreibh@simula.no>  Tue, 18 Nov 2025 15:17:30 +0100
