## dynmhs 0.3.1

=== debian/changelog ===
dynmhs (0.3.1-1) unstable; urgency=low

  * Closes: #1099114 (ITP).

 -- Thomas Dreibholz <dreibh@simula.no>  Tue, 09 Dec 2025 17:21:38 +0100
