=== debian/control ===
--- 
+++ 
@@ -3,8 +3,6 @@
 Priority: optional
 Maintainer: Thomas Dreibholz <dreibh@simula.no>
 Homepage: https://www.nntb.no/~dreibh/dynmhs/
-Vcs-Git: https://github.com/simula/dynmhs.git
-Vcs-Browser: https://github.com/simula/dynmhs
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libboost-log-dev,
